classification
Title: Speed hack for function calls with named parameters
Type: enhancement Stage:
Components: Interpreter Core Versions: Python 2.6
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: georg.brandl Nosy List: christian.heimes, facundobatista, georg.brandl, gvanrossum, lemburg, pitrou, rhettinger
Priority: normal Keywords: patch

Created on 2008-01-14 00:48 by pitrou, last changed 2008-07-25 22:15 by pitrou. This issue is now closed.

Files
File name Uploaded Description Edit
namedparam.patch pitrou, 2008-01-14 00:48
namedparam.patch pitrou, 2008-01-14 01:01
namedparam2.patch pitrou, 2008-06-11 18:38
namedparam3.patch rhettinger, 2008-06-12 00:52 Faster, cleaner with PySequence_Fast_ITEMS
pybench.patch pitrou, 2008-06-12 18:19
Messages (12)
msg59878 - (view) Author: Antoine Pitrou (pitrou) * (Python committer) Date: 2008-01-14 00:48
This is a patch for SVN trunk which substantially speeds up function
calls with named parameters. It does so by taking into account that
parameter names should be interned, so before doing full compares we do
a first quick loop to compare pointers.

On a microbenchmark the speedup is quite distinctive:

# With patch
$ ./python -m timeit -s "def f(a,b,c,d,e): pass" "f(1,2,3,4,e=5)"
1000000 loops, best of 3: 0.515 usec per loop
$ ./python -m timeit -s "def f(a,b,c,d,e): pass" "f(a=1,b=2,c=3,d=4,e=5)"
1000000 loops, best of 3: 0.652 usec per loop

# Without patch
$ ./python-orig -m timeit -s "def f(a,b,c,d,e): pass" "f(1,2,3,4,e=5)"
1000000 loops, best of 3: 0.664 usec per loop
$ ./python-orig -m timeit -s "def f(a,b,c,d,e): pass"
"f(a=1,b=2,c=3,d=4,e=5)"
1000000 loops, best of 3: 1.07 usec per loop
msg59879 - (view) Author: Christian Heimes (christian.heimes) * (Python committer) Date: 2008-01-14 00:54
Nice! Is this somehow related to #1479611?

The formatting of the code looks kinda strange. Have you mixed tabs and
spaces?
msg59880 - (view) Author: Antoine Pitrou (pitrou) * (Python committer) Date: 2008-01-14 01:01
Sorry, my editor indents with spaces by default. Attaching a fixed patch
with tabs.

No, it is independent from #1479611 (and much simpler).
msg59882 - (view) Author: Antoine Pitrou (pitrou) * (Python committer) Date: 2008-01-14 01:25
Another quick test:

# With patch
$ ./python -m timeit -s "d=dict(a=1,b=2,c=3,d=4,e=5);f = lambda
a,b,c,d,e:0" "f(**d)"
1000000 loops, best of 3: 0.727 usec per loop
$ ./python -m timeit -s "d=dict(b=2,c=3,d=4,e=5);f = lambda a,b,c,d,e:0"
"f(a=1,**d)"
1000000 loops, best of 3: 1.16 usec per loop
$ ./python -m timeit -s "d=dict(b=2,c=3,d=4,e=5); f=lambda **kw:0" "f(**d)"
1000000 loops, best of 3: 0.917 usec per loop

# Without patch
$ ./python-orig -m timeit -s "d=dict(a=1,b=2,c=3,d=4,e=5);f = lambda
a,b,c,d,e:0" "f(**d)"
1000000 loops, best of 3: 1.24 usec per loop
$ ./python-orig -m timeit -s "d=dict(b=2,c=3,d=4,e=5);f = lambda
a,b,c,d,e:0" "f(a=1,**d)"
1000000 loops, best of 3: 1.62 usec per loop
$ ./python-orig -m timeit -s "d=dict(b=2,c=3,d=4,e=5); f=lambda **kw:0"
"f(**d)"
1000000 loops, best of 3: 0.904 usec per loop
msg61556 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2008-01-23 04:48
Nice idea, but why set the priority to high?  I have no immediate time
to review this and probably won't for a while.
msg68007 - (view) Author: Antoine Pitrou (pitrou) * (Python committer) Date: 2008-06-11 18:38
Here is a new patch against SVN trunk. Nothing changed, except that I
updated pybench to test keyword arguments as well.
msg68025 - (view) Author: Marc-Andre Lemburg (lemburg) * (Python committer) Date: 2008-06-11 21:28
On 2008-06-11 20:38, Antoine Pitrou wrote:
> Antoine Pitrou <pitrou@free.fr> added the comment:
> 
> Here is a new patch against SVN trunk. Nothing changed, except that I
> updated pybench to test keyword arguments as well.
> 
> Added file: http://bugs.python.org/file10590/namedparam2.patch

When changing parameters or other aspects of pybench tests, you *have*
to update the version number of the test as well. Otherwise, pybench
would compare apples with oranges.

Thanks,
-- 
Marc-Andre Lemburg
eGenix.com

Professional Python Services directly from the Source  (#1, Jun 11 2008)
 >>> Python/Zope Consulting and Support ...        http://www.egenix.com/
 >>> mxODBC.Zope.Database.Adapter ...             http://zope.egenix.com/
 >>> mxODBC, mxDateTime, mxTextTools ...        http://python.egenix.com/
________________________________________________________________________
2008-07-07: EuroPython 2008, Vilnius, Lithuania            25 days to go

:::: Try mxODBC.Zope.DA for Windows,Linux,Solaris,MacOSX for free ! ::::

    eGenix.com Software, Skills and Services GmbH  Pastor-Loeh-Str.48
     D-40764 Langenfeld, Germany. CEO Dipl.-Math. Marc-Andre Lemburg
            Registered at Amtsgericht Duesseldorf: HRB 46611
msg68026 - (view) Author: Marc-Andre Lemburg (lemburg) * (Python committer) Date: 2008-06-11 21:29
On 2008-06-11 23:27, M.-A. Lemburg wrote:
> On 2008-06-11 20:38, Antoine Pitrou wrote:
>> Antoine Pitrou <pitrou@free.fr> added the comment:
>>
>> Here is a new patch against SVN trunk. Nothing changed, except that I
>> updated pybench to test keyword arguments as well.
>>
>> Added file: http://bugs.python.org/file10590/namedparam2.patch
> 
> When changing parameters or other aspects of pybench tests, you *have*
> to update the version number of the test as well. Otherwise, pybench
> would compare apples with oranges.

BTW: It would probably be better to add a completely new test
PythonNamedParameterCalls or something along those lines instead
of changing an existing test.
msg68040 - (view) Author: Raymond Hettinger (rhettinger) * (Python committer) Date: 2008-06-12 00:52
Attaching a version that's a little faster and cleaner with 
PySequence_Fast_ITEMS.
msg68070 - (view) Author: Antoine Pitrou (pitrou) * (Python committer) Date: 2008-06-12 18:19
And here is a patch adding a new test in pybench as suggested by
Marc-Andre Lemburg.
msg68092 - (view) Author: Raymond Hettinger (rhettinger) * (Python committer) Date: 2008-06-12 21:19
Georg, do you want to go ahead and apply this.
msg70283 - (view) Author: Antoine Pitrou (pitrou) * (Python committer) Date: 2008-07-25 22:15
Committed in r65240 (new pybench test) and r65241 (speedup patch).
History
Date User Action Args
2010-01-20 16:14:22brian.curtinlinkissue2015 superseder
2008-07-25 22:15:07pitrousetstatus: open -> closed
resolution: fixed
messages: + msg70283
2008-06-12 21:19:20rhettingersetmessages: + msg68092
2008-06-12 18:19:43pitrousetfiles: + pybench.patch
messages: + msg68070
2008-06-12 00:52:10rhettingersetfiles: + namedparam3.patch
nosy: + rhettinger
messages: + msg68040
2008-06-11 21:29:47lemburgsetmessages: + msg68026
2008-06-11 21:28:19lemburgsetnosy: + lemburg
messages: + msg68025
2008-06-11 18:58:55georg.brandlsetassignee: gvanrossum -> georg.brandl
nosy: + georg.brandl
2008-06-11 18:38:38pitrousetfiles: + namedparam2.patch
messages: + msg68007
2008-01-23 04:48:41gvanrossumsetpriority: high -> normal
messages: + msg61556
2008-01-14 16:05:14facundobatistasetnosy: + facundobatista
2008-01-14 01:25:38pitrousetmessages: + msg59882
2008-01-14 01:01:48pitrousetfiles: + namedparam.patch
messages: + msg59880
2008-01-14 00:54:44christian.heimessetpriority: high
assignee: gvanrossum
messages: + msg59879
keywords: + patch
nosy: + christian.heimes, gvanrossum
2008-01-14 00:49:02pitrousettype: enhancement
2008-01-14 00:48:19pitroucreate